//дерево відрізків, одинична модифікація
#include <iostream>
#include <fstream>

using namespace std;

#define MAX 1000001
long long SegTree[4*MAX];
int m[MAX];

void BuildTree(int *a, int v, int Left, int Right)
{
  if (Left == Right) SegTree[v] = a[Left];
  else
  {
    int Middle = (Left + Right) / 2;
    BuildTree(a, v*2, Left, Middle);
    BuildTree(a, v*2+1, Middle+1, Right);
    SegTree[v] = SegTree[v*2] + SegTree[v*2+1];
  }
}

int Get(int v, int LeftPos, int RightPos, long long Weight)
{
  if (LeftPos == RightPos) return SegTree[v] <= Weight;
  int Middle = (LeftPos + RightPos) / 2;
  if (SegTree[2*v] > Weight)
    return Get(2*v,LeftPos,Middle,Weight);
  else
    return Middle - LeftPos + 1 +
           Get(2*v+1,Middle+1,RightPos,Weight - SegTree[2*v]);
}

void update(int v, int LeftPos, int RightPos, int Position, int NewValue)
{
  if (LeftPos == RightPos) SegTree[v] = NewValue;
  else
  {
    int Middle = (LeftPos + RightPos) / 2;
    if (Position <= Middle)
      update (v*2, LeftPos, Middle, Position, NewValue);
    else update (v*2+1, Middle+1, RightPos, Position, NewValue);
    SegTree[v] = SegTree[v*2] + SegTree[v*2+1];
  }
}
int main()
{
int n;
scanf("%d",&n);
for(int i = 1; i <= n; i++) scanf("%d",&m[i]);
BuildTree(m,1,1,n);
int q,op, Weight;
scanf("%d",&q);
for(int i = 0; i < q; i++)
{
  scanf("%d",&op);
  if (op == 1)
  {
    scanf("%d",&Weight);
    printf("%d\n",Get(1,1,n,Weight));
  } else
  {
    int x,y;
    scanf("%d %d",&x,&y);
    update(1,1,n,x,y);
  }
}
return 0;
}